package com.qmth.sop.business.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.sop.business.bean.result.DeviceInOutResult;
import com.qmth.sop.business.entity.TBDeviceInOut;
import com.qmth.sop.business.mapper.TBDeviceInOutMapper;
import com.qmth.sop.business.service.TBDeviceInOutService;
import com.qmth.sop.common.contant.SystemConstant;
import com.qmth.sop.common.enums.DeviceStatusEnum;
import com.qmth.sop.common.enums.DeviceUsageTypeEnum;
import com.qmth.sop.common.enums.InOutTypeEnum;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 设备出入库登记 服务实现类
 * </p>
 *
 * @author wangliang
 * @since 2023-08-01
 */
@Service
public class TBDeviceInOutServiceImpl extends ServiceImpl<TBDeviceInOutMapper, TBDeviceInOut> implements TBDeviceInOutService {

    @Override
    public IPage<DeviceInOutResult> findDeviceInOutPageBySop(Long serviceUnitId, DeviceUsageTypeEnum usageType, Long userId, DeviceStatusEnum deviceStatus, Long inOutTimeStart, Long inOutTimeEnd, String deviceNo, String customName, String location, String address, Integer pageNumber, Integer pageSize) {
        deviceNo = SystemConstant.translateSpecificSign(deviceNo);
        customName = SystemConstant.translateSpecificSign(customName);
        location = SystemConstant.translateSpecificSign(location);
        address = SystemConstant.translateSpecificSign(address);

        return this.baseMapper.findDeviceInOutPageBySop(new Page<>(pageNumber, pageSize), serviceUnitId, usageType,
                userId, deviceStatus, inOutTimeStart, inOutTimeEnd, deviceNo, customName, location, address);
    }

    @Override
    public Object findDeviceInInfo() {
        return null;
    }

    @Override
    public Object findDeviceOutInfo() {
        return null;
    }

    @Override
    public void deviceInOutSubmit() {

    }

    @Override
    public IPage<DeviceInOutResult> findDeviceInOutPageBySource(Long serviceUnitId, InOutTypeEnum inOutType, String deviceNo, Long inOutTimeStart, Long inOutTimeEnd, Long supplierId, String customName, Integer pageNumber, Integer pageSize) {
        deviceNo = SystemConstant.translateSpecificSign(deviceNo);
        customName = SystemConstant.translateSpecificSign(customName);

        return this.baseMapper.findDeviceInOutPageBySource(new Page<>(pageNumber, pageSize), serviceUnitId, inOutType,
                deviceNo, inOutTimeStart, inOutTimeEnd, supplierId, customName);
    }
}
